<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../.resources/report.css" type="text/css"/><link rel="shortcut icon" href="../.resources/report.gif" type="image/gif"/><title>ParseException.java</title><link rel="stylesheet" href="../.resources/prettify.css" type="text/css"/><script type="text/javascript" src="../.resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../.sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">testBundle</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler.generated</a> &gt; <span class="el_source">ParseException.java</span></div><h1>ParseException.java</h1><pre class="source lang-java linenums">/* Generated By:JavaCC: Do not edit this line. ParseException.java Version 3.0 */
/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler.generated;

/**
 * This exception is thrown when parse errors are encountered.
 * You can explicitly create objects of this exception type by
 * calling the method generateParseException in the generated
 * parser.
 *
 * You can modify this class to customize your error reporting
 * mechanisms so long as you retain the public fields.
 */
public class ParseException extends Exception {

  /**
   * This constructor is used by the method &quot;generateParseException&quot;
   * in the generated parser.  Calling this constructor generates
   * a new object of this type with the fields &quot;currentToken&quot;,
   * &quot;expectedTokenSequences&quot;, and &quot;tokenImage&quot; set.  The boolean
   * flag &quot;specialConstructor&quot; is also set to true to indicate that
   * this constructor was used to create this object.
   * This constructor calls its super class with the empty string
   * to force the &quot;toString&quot; method of parent class &quot;Throwable&quot; to
   * print the error message in the form:
   *     ParseException: &lt;result of getMessage&gt;
   */
  public ParseException(Token currentTokenVal,
                        int[][] expectedTokenSequencesVal,
                        String[] tokenImageVal
                       )
  {
<span class="fc" id="L50">    super(&quot;&quot;);</span>
<span class="fc" id="L51">    specialConstructor = true;</span>
<span class="fc" id="L52">    currentToken = currentTokenVal;</span>
<span class="fc" id="L53">    expectedTokenSequences = expectedTokenSequencesVal;</span>
<span class="fc" id="L54">    tokenImage = tokenImageVal;</span>
<span class="fc" id="L55">  }</span>

  /**
   * The following constructors are for use by you for whatever
   * purpose you can think of.  Constructing the exception in this
   * manner makes the exception behave in the normal way - i.e., as
   * documented in the class &quot;Throwable&quot;.  The fields &quot;errorToken&quot;,
   * &quot;expectedTokenSequences&quot;, and &quot;tokenImage&quot; do not contain
   * relevant information.  The JavaCC generated code does not use
   * these constructors.
   */

  public ParseException() {
<span class="fc" id="L68">    super();</span>
<span class="fc" id="L69">    specialConstructor = false;</span>
<span class="fc" id="L70">  }</span>

  public ParseException(String message) {
<span class="fc" id="L73">    super(message);</span>
<span class="fc" id="L74">    specialConstructor = false;</span>
<span class="fc" id="L75">  }</span>

  /**
   * This variable determines which constructor was used to create
   * this object and thereby affects the semantics of the
   * &quot;getMessage&quot; method (see below).
   */
  protected boolean specialConstructor;

  /**
   * This is the last token that has been consumed successfully.  If
   * this object has been created due to a parse error, the token
   * followng this token will (therefore) be the first error token.
   */
  public Token currentToken;

  /**
   * Each entry in this array is an array of integers.  Each array
   * of integers represents a sequence of tokens (by their ordinal
   * values) that is expected at this point of the parse.
   */
  public int[][] expectedTokenSequences;

  /**
   * This is a reference to the &quot;tokenImage&quot; array of the generated
   * parser within which the parse error occurred.  This array is
   * defined in the generated ...Constants interface.
   */
  public String[] tokenImage;

  /**
   * This method has the standard behavior when this object has been
   * created using the standard constructors.  Otherwise, it uses
   * &quot;currentToken&quot; and &quot;expectedTokenSequences&quot; to generate a parse
   * error message and returns it.  If this object has been created
   * due to a parse error, and you do not catch it (it gets thrown
   * from the parser), then this method is called during the printing
   * of the final stack trace, and hence the correct error message
   * gets displayed.
   */
  public String getMessage() {
<span class="nc bnc" id="L116" title="All 2 branches missed.">    if (!specialConstructor) {</span>
<span class="nc" id="L117">      return super.getMessage();</span>
    }
<span class="nc" id="L119">    StringBuffer expected = new StringBuffer();</span>
<span class="nc" id="L120">    int maxSize = 0;</span>
<span class="nc bnc" id="L121" title="All 2 branches missed.">    for (int i = 0; i &lt; expectedTokenSequences.length; i++) {</span>
<span class="nc bnc" id="L122" title="All 2 branches missed.">      if (maxSize &lt; expectedTokenSequences[i].length) {</span>
<span class="nc" id="L123">        maxSize = expectedTokenSequences[i].length;</span>
      }
<span class="nc bnc" id="L125" title="All 2 branches missed.">      for (int j = 0; j &lt; expectedTokenSequences[i].length; j++) {</span>
<span class="nc" id="L126">        expected.append(tokenImage[expectedTokenSequences[i][j]]).append(&quot; &quot;);</span>
      }
<span class="nc bnc" id="L128" title="All 2 branches missed.">      if (expectedTokenSequences[i][expectedTokenSequences[i].length - 1] != 0) {</span>
<span class="nc" id="L129">        expected.append(&quot;...&quot;);</span>
      }
<span class="nc" id="L131">      expected.append(eol).append(&quot;    &quot;);</span>
    }
<span class="nc" id="L133">    String retval = &quot;Encountered \&quot;&quot;;</span>
<span class="nc" id="L134">    Token tok = currentToken.next;</span>
<span class="nc bnc" id="L135" title="All 2 branches missed.">    for (int i = 0; i &lt; maxSize; i++) {</span>
<span class="nc bnc" id="L136" title="All 2 branches missed.">      if (i != 0) retval += &quot; &quot;;</span>
<span class="nc bnc" id="L137" title="All 2 branches missed.">      if (tok.kind == 0) {</span>
<span class="nc" id="L138">        retval += tokenImage[0];</span>
<span class="nc" id="L139">        break;</span>
      }
<span class="nc" id="L141">      retval += add_escapes(tok.image);</span>
<span class="nc" id="L142">      tok = tok.next; </span>
    }
<span class="nc" id="L144">    retval += &quot;\&quot; at line &quot; + currentToken.next.beginLine + &quot;, column &quot; + currentToken.next.beginColumn;</span>
<span class="nc" id="L145">    retval += &quot;.&quot; + eol;</span>
<span class="nc bnc" id="L146" title="All 2 branches missed.">    if (expectedTokenSequences.length == 1) {</span>
<span class="nc" id="L147">      retval += &quot;Was expecting:&quot; + eol + &quot;    &quot;;</span>
    } else {
<span class="nc" id="L149">      retval += &quot;Was expecting one of:&quot; + eol + &quot;    &quot;;</span>
    }
<span class="nc" id="L151">    retval += expected.toString();</span>
<span class="nc" id="L152">    return retval;</span>
  }

  /**
   * The end of line string for this machine.
   */
<span class="fc" id="L158">  protected String eol = System.getProperty(&quot;line.separator&quot;, &quot;\n&quot;);</span>
 
  /**
   * Used to convert raw characters to their escaped version
   * when these raw version cannot be used as part of an ASCII
   * string literal.
   */
  protected String add_escapes(String str) {
<span class="fc" id="L166">      StringBuffer retval = new StringBuffer();</span>
      char ch;
<span class="fc bfc" id="L168" title="All 2 branches covered.">      for (int i = 0; i &lt; str.length(); i++) {</span>
<span class="pc bpc" id="L169" title="8 of 10 branches missed.">        switch (str.charAt(i))</span>
        {
           case 0 :
<span class="nc" id="L172">              continue;</span>
           case '\b':
<span class="nc" id="L174">              retval.append(&quot;\\b&quot;);</span>
<span class="nc" id="L175">              continue;</span>
           case '\t':
<span class="nc" id="L177">              retval.append(&quot;\\t&quot;);</span>
<span class="nc" id="L178">              continue;</span>
           case '\n':
<span class="nc" id="L180">              retval.append(&quot;\\n&quot;);</span>
<span class="nc" id="L181">              continue;</span>
           case '\f':
<span class="nc" id="L183">              retval.append(&quot;\\f&quot;);</span>
<span class="nc" id="L184">              continue;</span>
           case '\r':
<span class="nc" id="L186">              retval.append(&quot;\\r&quot;);</span>
<span class="nc" id="L187">              continue;</span>
           case '\&quot;':
<span class="nc" id="L189">              retval.append(&quot;\\\&quot;&quot;);</span>
<span class="nc" id="L190">              continue;</span>
           case '\'':
<span class="fc" id="L192">              retval.append(&quot;\\\'&quot;);</span>
<span class="fc" id="L193">              continue;</span>
           case '\\':
<span class="fc" id="L195">              retval.append(&quot;\\\\&quot;);</span>
<span class="fc" id="L196">              continue;</span>
           default:
<span class="nc bnc" id="L198" title="All 4 branches missed.">              if ((ch = str.charAt(i)) &lt; 0x20 || ch &gt; 0x7e) {</span>
<span class="nc" id="L199">                 String s = &quot;0000&quot; + Integer.toString(ch, 16);</span>
<span class="nc" id="L200">                 retval.append(&quot;\\u&quot; + s.substring(s.length() - 4, s.length()));</span>
<span class="nc" id="L201">              } else {</span>
<span class="nc" id="L202">                 retval.append(ch);</span>
              }
              continue;
        }
      }
<span class="fc" id="L207">      return retval.toString();</span>
   }

}
</pre><div class="footer"><span class="right">Created with <a href="$jacoco.home.url$">JaCoCo</a> $qualified.bundle.version$</span></div></body></html>